/******************************************************************
 *
 * File: hw2_orig.c
 * Author: Steve Wolfman
 *
 * Description: Starter code for CSE142 01sp HW #2.  See
 * http://www.cs.washington.edu/142/ (navigate to hw#2, 01sp) for
 * description of assignment.
 *
 ******************************************************************/

#include <stdio.h>   /* For I/O. */
#include "debug.h"   /* For debug_printf. */
#include <stdlib.h>  /* For rand/srand. */
#include <time.h>    /* For time (to seed rand). */
#include <assert.h>  /* For assert. */

/********* Useful constants **************/
#define UNRANDOM_SEED 0    /* 0 means seed as randomly as possible.  if 
							  this has a non-zero value, that value is
							  used as the random seed, giving consistent
							  choices of random #s from run to run. */

/********* Function prototypes ***********/
int    play_game(char mode);                  /* Play the LMAD game once.  */
int    random_int(int range);                 /* Produce a random integer. */

/********* Main function *****************/
int main(void)
{
	char dummy;            /* Dummy	var for pause at end. */

	play_game('i');        /* Play one game..
							* For now, ignores return type 
							* and hardwires parameter. */

	printf("Type any key and then hit ENTER to continue.. ");
	scanf(" %c", &dummy);

	/* Report success. */
	return 0;
}

/*********************************************************************
 * play_game:                                        
 *   takes a mode.                         
 *   in Part A, ignore this parameter.               
 *   in Part B:   ('s' for auto-switch,              
 *                 'k' for auto-keep)      
 *   and plays a game of LMAD (our style). In 's' or 'k' mode, the
 *   program makes all decisions. In switch, it always switches
 *   doors. In keep, it never does. In interactive (Part A) mode, the
 *   user makes all decisions.  
 *   Returns a 1 for a win or 0 for a loss.
 *                                                   
 * Part A preconditions: none.                       
 * Part B preconditions: mode is one of {'s', 'k'}   
 * postcondition: returns 1 iff won                  
 *********************************************************************/
int play_game(char mode)
{
  
	/* Check preconditions. */
	/* assert(mode == 's' || mode == 'k'); */ /* Not useful until part B */

	debug_printf("\n----------------------------------------------\n");
	debug_printf("Beggining game with mode %c.\n", mode);
  
	/* FILL ME IN!! */

	return 0;
}


/**********************************************************************
 * random_int                                        
 *   takes a positive number defining the range over which to draw a
 *   random number; returns random integer from 0 to num - 1: [0, num)
 *
 * Examples:
 *   int i = random_int(3) + 1;   (i's value is 1, 2, or 3 at random)
 *   int j = random_int(2);       (j is either 0 or 1. This is handy
 *                                 because this means 50% of the time,
 *                                 j is true and 50% of the time it's 
 *                                 false)
 *                                                   
 * precondition: range > 0                           
 * postcondition: returns an int from 0 to range-1   
 **********************************************************************/
int random_int(int range)
{
	static int initialized = 0;  /* Makes sure we only seed once. */
	double random_num;           /* Stores a random on [0, 1)     */
	int result;                  /* Stores our final result.      */

	/* Check preconditions. */
	assert(range > 0);
  
	/* "Seed" the random number generator exactly once. */
	if (!initialized) {
		if (UNRANDOM_SEED) {
			srand(UNRANDOM_SEED);
		}
		else {
			srand(time(NULL));
		}
		/* First "random" value is not very random. Discard it. */
		random_num = (double)rand();
		initialized = 1;
	}

	/* Get a random number in the range [0, 1) */
	random_num = (double)rand() / ((double)RAND_MAX + 1);

	/* Transform that into a random int from [0, range) */
	result = (int)(random_num * range);

	return result;
}


